> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.runtype.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.runtype.com/_mcp/server.

# Validate a standalone surface definition

POST https://api.runtype.com/v1/public/products/validate/surface
Content-Type: application/json

Validates a surface definition in isolation, without requiring a full product object.

Reference: https://docs.runtype.com/api-reference/runtype-api/product-validation/validate-a-standalone-surface-definition

## Servers

- `https://api.runtype.com` (Production, default)
- `https://api.runtype-staging.com` (Staging)

## Response

### 200

Validation result

- `errors` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaErrorsItems, required)
- `recommendations` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaRecommendationsItems, required)
- `valid` (boolean, required)
- `warnings` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaWarningsItems, required)

## Errors

### 400 Bad Request Error

Invalid JSON body

- `error` (string, required)
- `code` (string, optional) — Stable error code. `insufficient_scope` marks an API key that lacks a scope this request needs.
- `details` (list of ErrorDetailsItems, optional)
- `requiredScopes` (list of string, optional) — On `insufficient_scope`: every API key scope this request needs.

### 500 Internal Server Error

Validation failed unexpectedly

- `errors` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaErrorsItems, required)
- `recommendations` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaRecommendationsItems, required)
- `valid` (boolean, required)
- `warnings` (list of V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaWarningsItems, required)

## Types

### V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaErrorsItems

- `code` (string, required)
- `message` (string, required)
- `path` (string, required)
- `severity` (string, required)

### V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaRecommendationsItems

- `code` (string, required)
- `message` (string, required)
- `path` (string, required)
- `severity` (string, required)

### V1PublicProductsValidateSurfacePostResponsesContentApplicationJsonSchemaWarningsItems

- `code` (string, required)
- `message` (string, required)
- `path` (string, required)
- `severity` (string, required)

### ErrorDetailsItems

- `message` (string, required)
- `code` (string, optional) — Stable Runtype validation code (e.g. MISSING_REQUIRED_FIELD, INVALID_ENUM).
- `path` (string, optional) — Dotted JSON path to the offending field.
- `suggestion` (string, optional) — Actionable hint (allowed values, accepted range, …).

## Examples

**Request**

```json
{
  "config": {
    "theme": "default"
  },
  "id": "chat-widget",
  "name": "Chat Widget",
  "routes": [
    {
      "capabilityId": "chat"
    }
  ],
  "type": "chat"
}
```

**Response**

```json
{
  "errors": [
    {
      "code": "string",
      "message": "string",
      "path": "string",
      "severity": "string"
    }
  ],
  "recommendations": [
    {
      "code": "string",
      "message": "string",
      "path": "string",
      "severity": "string"
    }
  ],
  "valid": true,
  "warnings": [
    {
      "code": "string",
      "message": "string",
      "path": "string",
      "severity": "string"
    }
  ]
}
```

**SDK Code**

```python Validate a standalone surface definition
import requests

url = "https://api.runtype.com/v1/public/products/validate/surface"

payload = {
    "config": { "theme": "default" },
    "id": "chat-widget",
    "name": "Chat Widget",
    "routes": [{ "capabilityId": "chat" }],
    "type": "chat"
}
headers = {"Content-Type": "application/json"}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Validate a standalone surface definition
const url = 'https://api.runtype.com/v1/public/products/validate/surface';
const options = {
  method: 'POST',
  headers: {'Content-Type': 'application/json'},
  body: '{"config":{"theme":"default"},"id":"chat-widget","name":"Chat Widget","routes":[{"capabilityId":"chat"}],"type":"chat"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Validate a standalone surface definition
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.runtype.com/v1/public/products/validate/surface"

	payload := strings.NewReader("{\n  \"config\": {\n    \"theme\": \"default\"\n  },\n  \"id\": \"chat-widget\",\n  \"name\": \"Chat Widget\",\n  \"routes\": [\n    {\n      \"capabilityId\": \"chat\"\n    }\n  ],\n  \"type\": \"chat\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Validate a standalone surface definition
require 'uri'
require 'net/http'

url = URI("https://api.runtype.com/v1/public/products/validate/surface")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Content-Type"] = 'application/json'
request.body = "{\n  \"config\": {\n    \"theme\": \"default\"\n  },\n  \"id\": \"chat-widget\",\n  \"name\": \"Chat Widget\",\n  \"routes\": [\n    {\n      \"capabilityId\": \"chat\"\n    }\n  ],\n  \"type\": \"chat\"\n}"

response = http.request(request)
puts response.read_body
```

```java Validate a standalone surface definition
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.runtype.com/v1/public/products/validate/surface")
  .header("Content-Type", "application/json")
  .body("{\n  \"config\": {\n    \"theme\": \"default\"\n  },\n  \"id\": \"chat-widget\",\n  \"name\": \"Chat Widget\",\n  \"routes\": [\n    {\n      \"capabilityId\": \"chat\"\n    }\n  ],\n  \"type\": \"chat\"\n}")
  .asString();
```

```php Validate a standalone surface definition
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.runtype.com/v1/public/products/validate/surface', [
  'body' => '{
  "config": {
    "theme": "default"
  },
  "id": "chat-widget",
  "name": "Chat Widget",
  "routes": [
    {
      "capabilityId": "chat"
    }
  ],
  "type": "chat"
}',
  'headers' => [
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Validate a standalone surface definition
using RestSharp;

var client = new RestClient("https://api.runtype.com/v1/public/products/validate/surface");
var request = new RestRequest(Method.POST);
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"config\": {\n    \"theme\": \"default\"\n  },\n  \"id\": \"chat-widget\",\n  \"name\": \"Chat Widget\",\n  \"routes\": [\n    {\n      \"capabilityId\": \"chat\"\n    }\n  ],\n  \"type\": \"chat\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Validate a standalone surface definition
import Foundation

let headers = ["Content-Type": "application/json"]
let parameters = [
  "config": ["theme": "default"],
  "id": "chat-widget",
  "name": "Chat Widget",
  "routes": [["capabilityId": "chat"]],
  "type": "chat"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.runtype.com/v1/public/products/validate/surface")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```